import { ComponentFactoryResolver, ComponentRef, ElementRef, OnChanges, OnDestroy, Renderer2, SimpleChanges, ViewContainerRef } from '@angular/core';
import { CgBusyOptions } from './cgBusy.interface';
import { CgBusyService } from './cgBusy.service';
import { CgBusyDefaults } from './cgBusyDefaults.service';
import { CgBusyComponent } from './cgBusy.component';
import { Observable, Subscription } from 'rxjs';
export declare class CgBusyDirective implements OnChanges, OnDestroy {
    private viewContainer;
    private defaultOptions;
    private renderer;
    private componentFactoryResolver;
    private el;
    cgBusy: boolean | number | Promise<any> | Subscription | Observable<any>;
    cgBusyConfig: CgBusyOptions;
    tracker: CgBusyService;
    fakePromise: Promise<void>;
    fakePromiseResolve: () => void;
    $options: CgBusyOptions;
    $promise: (Promise<any> | Subscription | Observable<any>)[];
    componentRef: ComponentRef<CgBusyComponent>;
    constructor(viewContainer: ViewContainerRef, defaultOptions: CgBusyDefaults, renderer: Renderer2, componentFactoryResolver: ComponentFactoryResolver, el: ElementRef);
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
}
